import { BaseBatchUpdateStatusManager } from 'src/core/modules/domain/usecase/managers/base-batch-update-status.manager';
import { BannerEntity } from '../../entities/banner.entity';
import {
  EventTopics,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';
import { BannerModel } from '../../../data/models/banner.model';
import { BannerChangeStatusEvent } from '../../entities/event/banner-change-status.event';
import { BatchResult } from 'src/core/response/domain/ok-response.interface';
import { Injectable } from '@nestjs/common';

@Injectable()
export class BatchConfirmBannerManager extends BaseBatchUpdateStatusManager<BannerEntity> {
  validateData(data: BannerEntity): Promise<void> {
    return;
  }

  beforeProcess(): Promise<void> {
    return;
  }

  afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return BannerModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: BannerChangeStatusEvent,
      },
    ];
  }

  getResult(): BatchResult {
    return this.result;
  }
}
